package Src;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;



public class Graphe {
	
	// nb Sommets afin d'initialiser la liste des sommets
	public static int nbSommetsInit;
	
	// La liste des Sommets
	private ArrayList<Sommet> listeSommets;
	// La liste des successeurs
	private ArrayList<ArrayList<Successeur>> listeSucc;
	// On initialise le nb de sommets
	private int nbSommet = 0 ;
	
	
	
	/**
	 * Constructeur de la classe Graphe
	 * @param nbSommet
	 * @param nbSuccMax
	 * Pour l'initialisation du graphe
	 */
	public Graphe(int nbSommet, int[] nbSuccMax) {
		nbSommetsInit = nbSommet;
		listeSommets = new ArrayList<Sommet>(nbSommetsInit);
		listeSucc = new ArrayList<ArrayList<Successeur>>(nbSommetsInit);
		for(int i = 0; i<nbSommetsInit; i++)
			listeSucc.add(new ArrayList<Successeur>());
	}	
	
	/**
	 * Pour charger le graphe avec les listes initialis??s par la lecture des fichiers (sommets et successeurs)
	 * @param sommets
	 * @param succ
	 */
	public Graphe(ArrayList<Sommet> sommets, ArrayList<ArrayList<Successeur>> succ) {
		listeSommets = sommets;
		listeSucc = succ;
	}
	
	/**
	 * Renvoie la liste des sommets
	 */
	public ArrayList<Sommet> getListeSommets() {
		return listeSommets;
	}
	
	
	/**
	 * Charge la liste des sommets pour le graphe
	 */
	public void setListeSommets(ArrayList<Sommet> listeSommets) {
		this.listeSommets = listeSommets;
	}
	
	/**
	 * Renvoie la liste des successeurs
	 */
	public ArrayList<ArrayList<Successeur>> getListeSucc() {
		return listeSucc;
	}
		
	/**
	 * Cette fonction charge la liste des successeurs 
	 * @param listeSucc de type vecteur (liste des successeurs)
	 */
	public void setListeSucc(ArrayList<ArrayList<Successeur>> listeSucc) {
		this.listeSucc = listeSucc;
	}
	
	/**
	 * Renvoie le nb de sommets
	 */
	public int getNbSommet() {
		return nbSommet;
	}
	
	/*
	 * Ins??re un sommet dans le graphe (en r??cup??rant l'indice du Sommet)
	 */
	public void insererSommet(Sommet som){
		listeSommets.add(som.getIdSom(),som);
		this.nbSommet++;
	}
	
	/*
	 * Ajoute un successeurs pour un sommet donn??e
	 */
	public void ajouterSuccesseur(Successeur succ, Sommet som){
		
		
		//TODO
		//Lire le fichier .aretes + r??cup??rer le nombre de succ??sseurs par sommet dans un tableau
		//Initialiser en relisant le tableau (new)
		//Remplir en relisant le fichier
		//A FAIRE DANS LECTURE ARETES
		
		
			//listeSucc.ensureCapacity(som.getIdSom()+1);
		    //listeSucc.toArray()[som.getIdSom()] = new ArrayList<Successeur>(som.getIdSom());
			//listeSucc.ensureCapacity(10);
			
			//System.out.println(listeSucc.size());
			//listeSucc.set(som.getIdSom(), new ArrayList<Successeur>(50));
		   // System.out.println("machin");
		
		
		//Le tableau commence a 0 alors que les indices de sommets commencent a 1
		//listeSucc.get(som.getIdSom()).ensureCapacity((som.getIdSom()));
		//System.out.println("taill"+listeSucc.get(som.getIdSom()).size());
		listeSucc.get(som.getIdSom()).add(succ);
	}
	
	/*
	 * Dessine un graphe (soit avec la classe graphviz, soit en g??n??rant un fichier dot qui est ensuite
	 * charg?? gr??ce ?? la commande syst??me nateo)
	 * option (varargs) est une liste des options affect??es ?? la fonction
	 */
	
	public void dessinerGraphe(String...option) throws IOException{
		
		
		//TODO
		//A FAIRE : SI LE SOMMET NA PAS DE NOM, IL FAUT METTRE SON NUM??RO!!!
		GraphViz gv = new GraphViz();
		gv.addln(gv.start_graph()); 
		gv.addln("graph [bgcolor=lightyellow2, splines=true];");
		gv.addln("edge [color=blue, arrowsize=0.5, arrowhead=open, labelfontsize=7, labelfontname=Verdana, color=green];");
		gv.addln("node [color=lightgray, style=filled, fontname=\"Verdana\", fontsize=8, shape=box, width=0, margin=\"0.0,0.0\", height=0, pack=0, fontcolor=red];");

		//gv.addln("graph [style=random];");
		//gv.addln("node [color=lightgray, style=filled, fontname=\"Verdana\", fontsize=8, shape=box, width=0, margin=\"0.0,0.0\", height=0, pack=0, fontcolor=red];");
		for(int i=0; i<this.getListeSommets().size();i++){
			if(this.getListeSommets().get(i) != null){
				Sommet som1 = ((Sommet)(this.getListeSommets().get(i)));
				gv.addln("\""+som1.getNom()+"\" [pos=\" "+(int)(som1.getLongitude()*100)+", "+(int)(som1.getLatitude()*100)+"\"];");
				for(int j=0; j<((this.getListeSucc().get(i))).size();j++){
					if((this.getListeSucc().get(i)).get(j) != null){
						Successeur succ1 = ((Successeur)((this.getListeSucc().get(i)).get(j)));
						Sommet som2 = ((Sommet)(this.getListeSommets().get(succ1.getNumSommet())));
						gv.addln("\""+som1.getNom() + "\" -> \"" + som2.getNom()+"\";");
						//gv.addln("\""+som1.getNom() + "\" -> \"" + som2.getNom()+"\" [label= \"Distance : "+succ1.getValuationArc().getDistance()+"\"];");
						
					}
				}
			}
		}
		gv.addln(gv.end_graph());
		System.out.println(gv.getDotSource());
			
		
		for (String current : option)
		{
			// m??thode en g??n??rant le fichier dot
			if (current.compareTo("neato")==0) {
				FileWriter out = new FileWriter("notreGraphe.dot");
				out.write(gv.getDotSource());
				out.flush();
				String cmd = "neato -s -n2 -Tjpg -ocarte.jpg notreGraphe.dot";
				try {
						Runtime r = Runtime.getRuntime();
						Process p = r.exec(cmd);
						p.waitFor();//si l'application doit attendre a ce que ce process fini
					}catch(Exception e) {
						System.out.println("erreur d'execution " + cmd + e.toString()); 
					}
			}
			// m??thode en utilisant graphviz
			else if (current.compareTo("graphviz")==0) {
				File out = new File("Graphe.gif");
				gv.writeGraphToFile(gv.getGraph(gv.getDotSource()), out);
			}
		}
		
	   
	
		
	    
	}
	
// Ancienne fonction pour l'affichage du graphe	
//	public void printSommets(String...option) throws IOException{
//		GraphViz gv = new GraphViz();
//		gv.addln(gv.start_graph()); 
//		gv.addln("graph [bgcolor=lightyellow2, splines=true];");
//		gv.addln("edge [color=blue, arrowsize=0.5, arrowhead=open, labelfontsize=7, labelfontname=Verdana, color=green];");
//		gv.addln("node [color=lightgray, style=filled, fontname=\"Verdana\", fontsize=8, shape=box, width=0, margin=\"0.0,0.0\", height=0, pack=0, fontcolor=red];");
//
//		for(int i=1; i<this.getListeSommets().size();i++){
//			if((this.getListeSommets().get(i) != null)/* && !((((Sommet)(this.getListeSommets().elementAt(i-1))).getNom()).equals(((Sommet)(this.getListeSommets().elementAt(i))).getNom()))*/){
//				Sommet som1 = ((Sommet)(this.getListeSommets().get(i)));
//				//System.out.println(som1.getNom());
//				gv.addln("\""+som1.getNom()+"\" [pos=\" "+(som1.getLongitude())+", "+(som1.getLatitude())+"\"];");
//			}
//		}
//		gv.addln(gv.end_graph());
//		//System.out.println(gv.getDotSource());
//		//File out = new File("Graphe.gif");
//		FileWriter out = new FileWriter("notreGraphe.dot");
//		out.write(gv.getDotSource());
//		out.flush();
//		for (String current : option)
//		{
//			if (current.compareTo("neato")==0) {
//				out.write(gv.getDotSource());
//				out.flush();
//				String cmd = "neato -s -n2 -Tjpg -ocarte.jpg notreGraphe.dot";
//				try {
//						Runtime r = Runtime.getRuntime();
//						Process p = r.exec(cmd);
//						p.waitFor();//si l'application doit attendre a ce que ce process fini
//					}catch(Exception e) {
//						System.out.println("erreur d'execution " + cmd + e.toString()); 
//					}
//			}
//			else if (current.compareTo("graphviz")==0) {
//				File outviz = new File("Graphe.gif");
//				gv.writeGraphToFile(gv.getGraph(gv.getDotSource()), outviz);
//			}
//		}
//		
//	    
//	}
	
	/*
	 * Pour afficher le graphe (sommets et successeurs) sous forme textuelle
	 */
	@SuppressWarnings("static-access")
	public String toString(){
		String result ="";
		//Parcour de tous les sommets
		for(int i =0; i<this.nbSommetsInit;i++){
			if(this.getListeSommets().get(i) != null)
				System.out.println(this.getListeSommets().get(i).toString());
				//result = result + this.getListeSommets().get(i).toString() + "\n";
		}
		result = result + "\n";
		//Parcour de tous les successeurs
		for(int i =0; i<this.nbSommetsInit;i++){
			if(this.getListeSucc().get(i) != null){
				for(int j = 0; j< (this.getListeSucc().get(i)).size();j++){
					if((this.getListeSucc().get(i)).get(j) != null){
						System.out.println(i +" vers " + (this.getListeSucc().get(i)).get(j).toString());
						//result = result + i +" vers " + (this.getListeSucc().get(i)).get(j).toString() + "\n";
					}
				}
			}
		}
		return null;//result;
	}
	
	/*
	 * methode qui permet de recuperer le numero d'un sommet en fonction de son nom 
	 * (a utiliser avec parcimonie, c'est plutot lourd ..)
	 */
	public int num(String nom){
		int i = 0;
		while(i < this.nbSommet){
			if (listeSommets.get(i).getNom().equals(nom))
				return listeSommets.get(i).getIdSom();
			else 
				i++;
		}	
		return -1;
	}
	
	/*
	 * methode pour recuperer le nom d'un sommet a partir de son numero
	 */
	public String nom(int numSommet){
		return listeSommets.get(numSommet).getNom();
	}
	
	
	public void setStation(int numSommet){
		Sommet som = listeSommets.get(numSommet);
		som.setStation();
		listeSommets.set(numSommet,som);
	}
	/*
	 * methode pour savoir si un sommet a une station
	 */
	
	public boolean aStation(int numSommet){
		return listeSommets.get(numSommet).isStation();
	}
}
